stages:
  - checks
  - build
  - test
  - deploy
  - dast
  - performance

lint:
  stage: checks
  image: python:3.9
  before_script:
    - make develop
  script:
    - make lint

unit_tests:
  stage: checks
  image: python:3.9

  # Lancer un conteneur avec un Postgres configuré avec Postgis
  services:
  - name: postgis/postgis:14-3.2-alpine
    alias: postgis

  variables:
    # Configuration du service Postgres
    POSTGRES_DB: test_zonages
    POSTGRES_USER: zonages
    POSTGRES_PASSWORD: zonages

    # Configuration de l’application
    DBHOST: postgis
    DBUSER: $POSTGRES_USER
    DBPASS: $POSTGRES_PASSWORD
    TEST_DBNAME: $POSTGRES_DB

  before_script:
    - apt-get update -qy
    - apt-get install -y locales
    - echo fr_FR.UTF-8 UTF-8 >> /etc/locale.gen
    - locale-gen fr_FR.UTF-8
    - locale -a
    - make develop
  script:
    - make test

test-update-data:
  stage: checks
  image: python:3.9

  # Lancer un conteneur avec un Postgres configuré avec Postgis
  services:
  - name: postgis/postgis:14-3.2-alpine
    alias: postgis

  variables:
    # Configuration du serveur Postgres
    POSTGRES_USER: zonages
    POSTGRES_PASSWORD: zonages
    POSTGRES_DB: zonages

    # Configuration de psql
    PGHOST: postgis
    PGUSER: $POSTGRES_USER
    PGPASSWORD: $POSTGRES_PASSWORD
    PGDATABASE: $POSTGRES_DB

  before_script:
    - apt-get update -qy
    - apt-get install -y wget unzip p7zip-full postgis gdal-bin
    - make develop

  script:
    - make update_data

include:
  - project: vigigloo/gitlab-pipeline-fragments
    ref: v1
    file:
      # Required
      - /helm.yml

      # build
      - /docker.auto.yml

      # test
      - /proxy/license-scanning.yml
      # - /proxy/code-quality.yml
      - /proxy/dependency-scanning.yml
      - /proxy/container-scanning.yml
      - /proxy/sast.yml
      # - /proxy/secret-scanning.yml

      # deploy
      - /helm.development.auto.yml
      - /helm.production.auto.yml

variables:
  HELM_REPOSITORY: https://gitlab.com/api/v4/projects/29298483/packages/helm/stable
  HELM_CHART: nodejs
  HELM_NAME: backend
  HOST: zonages.${BASE_DOMAIN}
  HELM_INGRESS_HOST: ${HOST}

.docker:build:updatedata:
  variables:
    CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/updatedata/$CI_COMMIT_REF_SLUG"
    CI_APPLICATION_TAG: "$CI_COMMIT_SHA"
    CI_APPLICATION_TAG_LATEST: latest
    DOCKERFILE: "$CI_PROJECT_DIR/update_data.Dockerfile"
    DOCKER_CONTEXT: "$CI_PROJECT_DIR"
  environment: null

docker:build:updatedata:reviews:
  extends:
    - docker:kaniko:build:reviews
    - .docker:build:updatedata
docker:build:updatedata:development:
  extends:
    - docker:kaniko:build:development
    - .docker:build:updatedata
docker:build:updatedata:production:
  extends:
    - docker:kaniko:build:production
    - .docker:build:updatedata